--------------------------------------------------------------------------------
-- Racquet module --------------------------------------------------------------
--------------------------------------------------------------------------------

Racquet = {}

function Racquet.new()
	local _self = {}

	-- Private variables:
	local _x -- Racquet horizontal position
	local _y -- Racquet vertical position
	local _width -- Racquet width
	local _height -- Racquet height
	local _speed -- Racquet speed
	
	-- Private variables:
	-- TODO: add some private variables?
	
	-- Accessors:
	-- Getters
	function _self.getX()
		return _x
	end
	
	function _self.getY()
		return _y
	end
	
	function _self.getWidth()
		return _width
	end
	
	function _self.getHeight()
		return _height
	end
	
	-- Setters:
	-- TODO: add some private setters?
	
	-- Private methods:
	function slideRight(t)
		_x = _x + (_speed * 100 * t)
	end
	
	function slideLeft(t)
		_x = _x - (_speed * 100 * t)
	end
	
	-- Public methods:
	-- init method:
	function _self.init(x, y, width, height, speed)
		_x = x
		_y = y
		_width = width
		_height = height
		_speed = speed
	end
	
	-- update the racquet:
	function _self.update(t)
		-- If the right arrow key is pressed
		-- the racquet have to move to the right
		-- But we want to restrict the racket movements to avoid it goes off-limits
		if love.keyboard.isDown("right") and _x + _width <= love.graphics.getWidth() then
			slideRight(t)
		end
		-- If the left arrow key is pressed
		-- the racquet have to move to the left
		-- But we want to restrict the racket movements to avoid it goes off-limits
		if love.keyboard.isDown("left") and _x >= 0 then
	    	slideLeft(t)
		end
	end
	
	-- draw the racquet:
	function _self.draw()
		-- Racquet color
		love.graphics.setColor(255, 255, 255)
		-- Draw the racquet as quad
		love.graphics.quad(
			"fill",
			_x, _y, -- Top left corner x, y
			_x + _width, _y, -- Top right corner x, y
			_x + _width, _y + _height, -- Bottom right corner x, y
			_x, _y + _height -- Bottom left corner x, y
		)
	end
	
	return _self
end